routes/web.php
<?php


use App\Http\Controllers\CategoryController;

use App\Http\Controllers\EventController;

use App\Http\Controllers\MenuProductController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\CompanyController;
use App\Http\Controllers\MenuController;
use App\Http\Controllers\PromotionController;
use App\Http\Controllers\QrCodeController;
use Illuminate\Support\Facades\Route;


Route::get('/', function () {
    return view('auth.login');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth'])->name('dashboard');

require __DIR__ . '/auth.php';

Route::get('menus/{menu}/qrcode', [QrCodeController::class, 'viewQrCode'])->name('view-qr-code');
Route::get('companies/{company}/events', [EventController::class, 'welcome'])->name('events.welcome');

Route::controller(EventController::class)->middleware('auth')->group(function () {
    Route::get('events', [EventController::class, 'index'])->name('events');
    Route::get('events/create', [EventController::class, 'create'])->name('events-event.create');
    Route::post('events', [EventController::class, 'store'])->name('events.store');
    Route::get('events/{event}', [EventController::class, 'show'])->name('events.show');
    Route::get('events/{event}/promotions', [EventController::class, 'showPromotions'])->name('event.promotions.show');
    Route::put('events/{event}/promotions/{promotion}/add', [EventController::class, 'addPromotion'])->name('event.promotion.add');
    Route::get('events/{event}/edit', [EventController::class, 'edit'])->name('events.edit');
    Route::patch('events/{event}', [EventController::class, 'update'])->name('events.update');
    Route::get('events/{event}/delete', [EventController::class, 'destroy'])->name('events.delete');
});

Route::get('companies/{company}/promotions', [PromotionController::class, 'welcome'])->name('promotions.welcome');

Route::controller(PromotionController::class)->middleware('auth')->group(function () {
    Route::get('promotions', [PromotionController::class, 'index'])->name('promotions');
    Route::get('promotions/create', [PromotionController::class, 'create'])->name('promotions.create');
    Route::post('promotions', [PromotionController::class, 'store'])->name('promotions.store');
    Route::get('promotions/{promotion}', [PromotionController::class, 'show'])->name('promotions.show');
    Route::get('promotions/{promotion}/edit', [PromotionController::class, 'edit'])->name('promotions.edit');
    Route::put('promotions/{promotion}', [PromotionController::class, 'update'])->name('promotions.update');
    Route::get('promotions{promotion}', [PromotionController::class, 'destroy'])->name('promotions.delete');
});


Route::controller(ProductController::class)->middleware('auth')->group(function () {

    Route::get('/{menu}/{category}/products', [ProductController::class, 'welcome'])->name('products.welcome');
    Route::get('products', [ProductController::class, 'index'])->name('products');
    Route::get('products/create', [ProductController::class, 'create'])->name('products.create');
    Route::post('products', [ProductController::class, 'store'])->name('products.store');
    Route::get('products/{product}', [ProductController::class, 'show'])->name('products.show');
    Route::get('products/{product}/edit', [ProductController::class, 'edit'])->name('products.edit');
    Route::patch('products/{product}', [ProductController::class, 'update'])->name('products.update');
    Route::get('products/delete/{product}', [ProductController::class, 'destroy'])->name('products.delete');
});

Route::controller(CompanyController::class)->middleware('auth')->group(function () {
    Route::get('companies/', 'index')->name('companies');
    Route::get('companies/create', 'create')->name('companies-company.create');
    Route::get('companies/{company}/edit', 'edit')->name('companies-company.edit');
    Route::post('companies/store', 'store')->name('companies-company.store');
    Route::put('companies/{company}', 'update')->name('companies-company.update');
    Route::get('companies/{company}/delete', 'destroy')->name('companies-company.destroy');
    Route::get('{company}/menus/', 'showMenus')->name('company-menus.show');
    Route::get('{company}/promotions/', 'showPromotions')->name('company-promotions.show');
    Route::get('{company}/events/', 'showEvents')->name('company-events.show');
});

Route::get('companies/{company}', [CompanyController::class, 'show'])->name('companies-company.show');


Route::controller(MenuController::class)->middleware('auth')->group(function () {
    Route::get('menus/', 'index')->name('menus');
    Route::get('menus/create', 'create')->name('menus-menu.create');
    Route::get('menus/{company}', 'show')->name('menus-company.show');
    Route::get('menus/{menu}/edit', 'edit')->name('menus-menu.edit');
    Route::get('{menu}/products', 'showProducts')->name('menu-products.show');
    Route::post('menus/store', 'store')->name('menus-menu.store');
    Route::put('menus/{menu}', 'update')->name('menus-menu.update');
    Route::get('menus/{menu}/delete', 'destroy')->name('menus-menu.destroy');
});

Route::get('/{city:slug}/{company:slug}/{menu}', [MenuController::class, 'show'])->name('menus-menu.show');
Route::post('menus/{menu}/attach', [MenuProductController::class, 'attachProducts'])->name('menu-product.attach-products');

Route::get('/{company:slug}/{menu:slug}', [CategoryController::class, 'index'])->name('category.index');

/**
 *This route wasn't functional before. It was intended for listing products by their category.
 *There is a functional and updated route called -> (products.welcome)
 *Route::get('/{company:slug}/{category:slug} ', [CategoryController::class, 'show'])->name('company-category.show');
 */

app/Models/Company.php
<?php

namespace App\Models;

use App\Mail\NoEvents;
use App\Mail\NoPromotions;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;

class Company extends Model
{
    use HasFactory;
    use SoftDeletes;

    /**
     * The attributes that are not mass assignable.
     * @var array<int, string>
     */
    protected $guarded = [];


    public function scopePromotionsCount($query)
    {
        return $query->withCount('promotions');
    }

    public function events()
    {
        return $this->hasMany(Event::class);
    }

    public function promotions()
    {
        return $this->hasMany(Promotion::class);
    }

    public function owner()
    {
        return $this->belongsTo(User::class, 'owner_id');
    }

    public function menus()
    {
        return $this->hasMany(Menu::class);
    }

    public function city()
    {
        return $this->belongsTo(City::class);
    }

    /**
     * Return only user-created companies
     * @param $query
     * @return mixed
     */
    public function scopeOwned($query)
    {
        return $query->whereOwnerId(Auth::id());
    }

    public function sendPromotionReminder()
    {
        if ($this->promotions()->doesntExist()) {
            Mail::to($this->owner->email)->send(new NoPromotions());
        }
    }

    public function sendEventReminder()
    {
        if ($this->events()->doesntExist()) {
            Mail::to($this->owner->email)->send(new NoEvents());
        }
    }
}

app/Models/Menu.php
<?php

namespace App\Models;

use http\Env\Request;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;

class Menu extends Model
{

    use HasFactory;
    use SoftDeletes;

    protected $table = 'menus';

    /**
     * The attributes that are not mass assignable.
     * @var array<int, string>
     */
    protected $guarded = [];

    /**
     * Return only user-owned menus.
     * @param $query
     * @return mixed
     */
    public function scopeOwned($query)
    {
        return $query->whereRelation('company', 'owner_id', Auth::id()); //checks if the menu's company is owned by auth user
    }

    /**
     * Filter by company
     * @param $query
     * @param $company
     * @return mixed
     */
    public function scopeCompany($query, $company)
    {
        return $query->where('company_id', $company);

    }

    public function scopeProductsCount($query)
    {
        return $query->withCount('products');
    }

    /**
     *
     * Excludes soft deleted records, use productsWithTrashed() to include soft deleted records
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function products()
    {
        return $this->belongsToMany(Product::class, 'menu_product', 'menu_id', 'product_id')
//            ->whereNull('menu_product.deleted_at')
            ->withTimestamps()
            ->with('category:id,name,image')
            ->withPivot(['price','deleted_at']);

    }

    public function categories()
    {
        return $this->belongsToMany(
            Category::class,
            'menu_product',
            'menu_id',
            'category_id'
        )
            ->distinct();
    }

    /**
     *
     * Retrieves ALL records (active and soft deleted ones)
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function productsWithTrashed()
    {
        return $this->belongsToMany(Product::class, 'menu_product', 'menu_id', 'product_id')
            ->whereNotNull('menu_product.deleted_at')
            ->withTimestamps()
            ->withPivot(['deleted_at', 'name']);

    }

    public function company()
    {
        return $this->belongsTo(Company::class)->with('city');
    }

}

app/Http/Controllers/CompanyController.php
<?php

namespace App\Http\Controllers;

use App\Models\City;
use App\Models\Company;
use App\Models\Event;
use App\Models\Menu;
use App\Models\Promotion;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Str;

class CompanyController extends Controller
{

    //TODO add authorization
    /**
     * lists all companies
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function index()
    {
        return view('companies.index', [
            'companies' => Company::owned()->withCount('menus', 'promotions', 'events')->get()
        ]);
    }

    public function show(Company $company)
    {
        return view('companies.show', [
            'company' => $company,
            'menus' => $company->menus()->get()
        ]);
    }

    public function showMenus(Company $company)
    {
        $menus = Menu::owned()->with('categories')->where('company_id', $company->id)->productsCount()->get();

//        dd($company)
        return view('companies.show-menus', [
            'menus' => $menus,
            'company' => Company::whereId($company->id)->withCount('promotions', 'events')->first()
        ]);
    }

    public function showPromotions(Company $company)
    {

//        dd($company);
        return view('companies.show-promotions', [
            'assignedPromotions' => $company->promotions()->with('event')->get(),
            'unassignedPromotions' => Promotion::where('company_id', $company->id)->whereNull('event_id')->get(),
            'company' => $company
        ]);
    }

    public function showEvents(Company $company)
    {
        return view('companies.show-events', [
            'events' => $company->events()->promotionsCount()->get(),
            'company' => $company
        ]);
    }

    public function create()
    {
        return view('companies.create', [
            'cities' => City::all()
        ]);
    }

    /**
     * Stores a new company
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function store()
    {
        $user = auth()->user();

        $attributes = request()->validate([
            'name' => 'required',
            'city_id' => 'required',
            'contact_number' => 'nullable',
            'opens_at' => 'nullable',
            'closes_at' => 'nullable',
            'fb_link' => 'nullable',
            'ig_link' => 'nullable'
        ]);

//        dd($attributes);

        try {
            $user->companies()->create($attributes);
            return redirect()->back()->with('message', ['text' => 'Company created!', 'type' => 'success']);
        } catch (\Exception $e) {
            return redirect()->back()->with('message', ['text' => 'Try again!', 'type' => 'danger']);
        }
    }

    public function edit(Company $company)
    {
        $this->authorize('update', $company);

        return view('companies.update', [
            'company' => $company,
            'cities' => City::all()
        ]);
    }

    /**
     * Updates the name of the company
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function update(Company $company)
    {
        $this->authorize('update', $company);

        $attributes = request()->validate([
            'name' => 'nullable',
            'city_id' => 'nullable',
            'contact_number' => 'nullable',
            'opens_at' => 'nullable',
            'closes_at' => 'nullable',
            'fb_link' => 'nullable',
            'ig_link' => 'nullable'
        ]);

        try {
            Company::whereId($company->id)
                ->whereOwner(Auth::id())
                ->update($attributes);
            return redirect()->back()->with('message', ['text' => 'Company updated!', 'type' => 'success']);
        } catch (\Exception $e) {
            return redirect(route('company-show', $company))->with(
                'message',
                ['text' => 'Try again!!', 'type' => 'danger']
            );
        }
    }

    public function delete(Company $company)
    {
        $this->authorize('delete', $company);

        return view('companies.destroy', [
            'company' => $company
        ]);
    }

    /**
     * Deletes the company
     * @param  Company  $company
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function destroy(Company $company)
    {
        $this->authorize('delete', $company);

        try {
            $company->delete();
            return redirect()->back()->with('message', ['text' => 'Company deleted!', 'type' => 'success']);
        } catch (\Exception $e) {
            return redirect()->back()->with('message', ['text' => 'Try again!', 'type' => 'danger']);
        }
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/companies/create.blade.php
<x-app-layout>
    <div class="flex flex-wrap space-y-5 mx-auto relative justify-center">
        <div class="md:relative fixed md:py-2 py-3 px-10 rounded-b-lg w-full bg-green-300">
            navbar goes here
        </div>

        <div class="flex flex-wrap justify-center md:space-y-5 space-y-10">
            <div class="rounded-lg md:shadow-lg md:p-3 mx-auto">
                <p class="md:contents hidden md:text-lg text-sm">Enter Company Details</p>
            </div>

            <div class="w-full rounded-lg border-2 border-gray-200 shadow-lg p-5">
                <form action="{{route('companies-company.store')}}" method="POST">
                    @csrf
                    @method('POST')

                    <div class="flex flex-col justify-center space-y-2">
                        <div class="mx-15">
                            <label for="name" class="block">Company Name</label>
                            <input id="name" type="text" name="name" value="" class="w-2/3 px-2 p-1 rounded-lg capitalize mt-2">
                        </div>

                        <div>
                            <label for="contact_number" class="block">Contact Number</label>
                            <input id="contact_number" type="tel" name="contact_number" value="" class="w-2/3 px-2 p-1 rounded-lg mt-2">
                        </div>

                        <div>
                            <label for="logo" class="block">Choose Logo</label>
                            <input id="logo" type="file" name="logo" value="" class="w-full px-2 p-1 rounded-lg mt-2">
                        </div>

                        <div>
                            <label for="city" class="block">Choose City</label>
                            <select id="city"  name="city_id" class="w-2/3 px-2 p-1 rounded-lg capitalize bg-white mt-2">
                                @foreach($cities as $city)
                                    <option value="{{$city->id}}">{{ucfirst($city->name)}}</option>
                                @endforeach
                            </select>
                        </div>

                        <div class="flex flex-wrap justify-evenly">
                            <div>
                                <label for="opens_at" class="block">Opens at:</label>
                                <input type="time" id="opens_at"   name="opens_at" class="px-2 p-1 rounded-lg mt-2">
                            </div>

                            <div>
                                <label for="closes_at" class="block">Closes at:</label>
                                <input type="time" id="closes_at"   name="closes_at" class="px-2 p-1 rounded-lg mt-2">
                            </div>
                        </div>

                        <div>
                            <label for="fb_link" class="block">Facebook Profile</label>
                            <input id="fb_link" type="text" name="fb_link" value="" class="w-full px-2 p-1 rounded-lg mt-2">
                        </div>

                        <div>
                            <label for="ig_link" class="block">Instagram Profile</label>
                            <input id="ig_link" type="text" name="ig_link" value="" class="w-full px-2 p-1 rounded-lg mt-2">
                        </div>

                    </div>

                    <div class="flex justify-end space-x-4 mt-3">
                        <a href="{{url()->previous()}}" class="rounded-lg shadow-lg px-2 py-1 border-2 bg-white border-red-400">Cancel</a>
                        <button class="rounded-lg shadow-lg px-2 py-1 border-2 bg-white border-green-400" type="submit">Submit</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/companies/index.blade.php
<x-app-layout>
    <div class="flex flex-wrap space-y-5 mx-auto relative justify-center">
        <div class="md:relative fixed md:py-2 py-3 px-10 rounded-b-lg w-full bg-green-300">
            navbar goes here
        </div>

        {{--        NEED TO FIX MOBILE VIEW --}}

        <div
            class="md:p-3 mx-auto md:my-4 mb-5 mt-16 bg-white border-blue-400 rounded-lg shadow-lg px-2 py-1">
            <p class="md:text-lg text-sm"><a href="{{route('companies')}}" class="text-blue-400 capitalize">
                    {{auth()->user()->name}}</a>'s companies</p>
        </div>

        <div
            class="md:shadow-lg md:p-3 mx-auto md:my-4 mb-5 mt-16 border-2 border-blue-200 rounded-lg shadow-2xl px-2 py-1">
            <p class="md:text-lg text-sm">
                <a href="{{route('companies-company.create')}}" class="uppercase">add new
                    company</a>
            </p>
        </div>

        {{--        NEED TO FIX MOBILE VIEW --}}

        <div class="w-full mx-4">
            <div class="flex flex-wrap lg:space-x-4 space-y-4 lg:space-y-0 lg:flex-nowrap">
                @foreach($companies as $company)
                    {{--                    @dd($company)--}}
                    <div class="w-full lg:w-1/2 bg-gray-200 rounded-lg shadow-lg p-2 space-y-2 p-5 ">
                        <a href="{{route('companies-company.show', $company)}}" >
                            <div class="flex flex-wrap space-x-2 rounded-lg border-2 border-gray-200 mb-4 items-center shadow-lg">
                                <img class="rounded-lg w-10 h-10 m-1" src="{{$company->logo}}" alt="">
                                <p>{{$company->name}}</p>
                            </div>
                        </a>

                        <div
                            class="w-full lg:w-auto p-3 text-gray-800 text-center border border-b text-center block lg:table-cell relative lg:static">
                            <a href="{{route('companies-company.edit', $company)}}"
                               class="rounded-lg shadow-lg px-2 py-1 border-2 border-orange-400">Edit</a>
                            <a href="{{route('companies-company.destroy', $company)}}"
                               onclick="return confirm('This will delete the product!')"
                               class="rounded-lg shadow-lg px-2 py-1 border-2 border-red-400">Remove</a>
                        </div>

                        <div class="flex flex-col md:flex-row md:space-x-2 space-y-2 md:space-y-0 place-content-between">
                            <div class="rounded-lg shadow-lg py-2 px-4 space-y-2 border-2 border-gray-200">
                                <p>Active Menus: {{$company->menus_count}}</p>
                                <p>Active Promotions: {{$company->promotions_count}}</p>
                                <p>Active Events: {{$company->events_count}}</p>
                                <p>Opens at {{$company->opens_at}}</p>
                                <p>Closes at {{$company->closes_at}}</p>
                            </div>

                            <div class="py-4 px-4 space-y-2 text-center">
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('company-menus.show', $company)}}">Menus</a>
                                </p>
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('company-promotions.show', $company)}}">Promotions</a>
                                </p>
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('company-events.show', $company)}}">Events</a>
                                </p>
                            </div>
                        </div>
                    </div>
                @endforeach
            </div>
        </div>
    </div>


</x-app-layout>

resources/views/companies/show-events.blade.php
<x-app-layout>
    <div class="flex flex-wrap space-y-5 mx-auto relative justify-center">
        <div class="md:relative fixed md:py-2 py-3 px-10 rounded-b-lg w-full bg-green-300">
            navbar goes here
        </div>

        {{--        NEED TO FIX MOBILE VIEW --}}

        <div
                class="md:p-3 mx-auto md:my-4 mb-5 mt-16 bg-white border-blue-400 rounded-lg shadow-lg px-2 py-1">
            <p class="md:text-lg text-sm"><a href="{{route('companies')}}" class="text-blue-400 capitalize">
                    {{$company->name}}</a>'s events</p>
        </div>

        <div
                class="md:shadow-lg md:p-3 mx-auto md:my-4 mb-5 mt-16 border-2 border-blue-200 rounded-lg shadow-2xl px-2 py-1">
            <p class="md:text-lg text-sm">
                <a href="{{route('events-event.create')}}" class="uppercase">add new
                    event</a>
            </p>
        </div>

        {{--        NEED TO FIX MOBILE VIEW --}}

        <div class="w-full  mx-4">
            <div class="flex flex-wrap md:flex-nowrap lg:space-x-4 space-y-4 lg:space-y-0">
                @foreach($events as $event)
                    <div class="w-full md:w-1/2 h-full bg-gray-200 rounded-lg shadow-lg p-2 space-y-2 p-5">
                        <div class="flex space-x-2 rounded-lg border-2 border-gray-200 items-center shadow-lg mb-4">
                            <img class="rounded-lg w-10 h-10 m-1" src="{{$event->menu_logo}}" alt="">
                            <p>{{$event->name}}</p>
                        </div>

                        <div class="lg:w-auto p-3 text-gray-800 text-center border border-b text-center block lg:table-cell relative lg:static">
                            <a href="{{route('events.edit', $event)}}"
                               class="rounded-lg shadow-lg px-2 py-1 border-2 border-orange-400">Edit</a>
                            <a href="{{route('events.delete', $event)}}"
                               onclick="return confirm('This will delete the product!')"
                               class="rounded-lg shadow-lg px-2 py-1 border-2 border-red-400">Remove</a>
                        </div>

                        <div
                                class="flex flex-col h-52 md:flex-row md:space-x-2 space-y-2 md:space-y-0 place-content-between">
                            <div class="md:w-2/3 md:h-14 rounded-lg shadow-lg py-4 md:mt-2 px-4 space-y-2 border-2 border-gray-200">
                                <p>Number of Promotions: {{$event->promotions_count}}</p>
                            </div>
                            <div
                                    class="w-full md:h-auto h-2/3 bg-scroll bg-center bg-contain bg-no-repeat"
                                    style="background-image: url({{asset('images/1655200640.png')}});">
                            </div>
                            <div class="md:w-1/2 py-4 px-4 space-y-2 text-center">
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('event.promotions.show', $event)}}">View Promotions</a>
                                </p>
                            </div>
                        </div>
                    </div>
                @endforeach
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/companies/show-menus.blade.php
<x-app-layout>
    <div class="flex flex-wrap space-y-5 mx-auto relative justify-center">
        <div class="md:relative fixed md:py-2 py-3 px-10 rounded-b-lg w-full bg-green-300">
            navbar goes here
        </div>

        {{--        NEED TO FIX MOBILE VIEW --}}
{{--@dd($company);--}}
        <div
            class="md:p-3 mx-auto md:my-4 mb-5 mt-16 bg-white border-blue-400 rounded-lg shadow-lg px-2 py-1">
            <p class="md:text-lg text-sm"><a href="{{route('companies')}}" class="text-blue-400 capitalize">
                    {{$company->name}}</a>'s menus</p>
        </div>

        <div
            class="md:shadow-lg md:p-3 mx-auto md:my-4 mb-5 mt-16 border-2 border-blue-200 rounded-lg shadow-2xl px-2 py-1">
            <p class="md:text-lg text-sm">
                <a href="{{route('menus-menu.create')}}" class="uppercase">add new
                    menu</a>
            </p>
        </div>

        {{--        NEED TO FIX MOBILE VIEW --}}

        <div class="w-full mx-4">
            <div class="flex flex-wrap lg:space-x-4 space-y-4 lg:space-y-0 lg:flex-nowrap">
                @foreach($menus as $menu)
                    <div class="w-full lg:w-1/2 bg-gray-200 rounded-lg shadow-lg p-2 space-y-2 p-5 ">
                        <a href="{{route('category.index', ['company' => $company->id, 'menu' => $menu])}}">
                            <div
                                class="flex flex-wrap space-x-2 rounded-lg border-2 border-gray-200  items-center shadow-lg">
                                <img class="rounded-lg w-10 h-10 m-1" src="{{$menu->menu_logo}}" alt="">
                                <p>{{$menu->name}}</p>
                            </div>
                        </a>

                        <div
                            class="w-full lg:w-auto p-3 text-gray-800 text-center border border-b text-center block lg:table-cell relative lg:static">
                            <a href="{{route('menus-menu.edit', $menu)}}"
                               class="rounded-lg shadow-lg px-2 py-1 border-2 border-orange-400">Edit</a>
                            <a href="{{route('menus-menu.destroy', $menu)}}"
                               onclick="return confirm('This will delete the product!')"
                               class="rounded-lg shadow-lg px-2 py-1 border-2 border-red-400">Remove</a>
                        </div>
                        <div
                            class="flex flex-col md:flex-row md:space-x-2 space-y-2 md:space-y-0 place-content-between">
                            <div class="rounded-lg shadow-lg py-2 px-4 space-y-2 border-2 border-gray-200">
                                <p>Total Products: {{$menu->products_count}}</p>
                                <p>Total Categories: {{count($menu->categories)}}</p>
                                <?php
                                $now = \Illuminate\Support\Carbon::now('UTC');
                                ?>
                                <p>
                                    @if ($now->isBefore($company->closes_at))
                                        <span class="text-green-500">Open</span>
                                    @else
                                        {{--                                        NOT SETUP AS INTENDED--}}
                                        <span class="text-red-500">Closed</span>
                                    @endif
                                </p>
                                <p>Work Time {{$company->opens_at}} : {{$company->closes_at}}</p>
                            </div>

                            <div class="py-4 px-4 space-y-2 text-center">
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('menu-products.show', $menu)}}">Products</a>
                                </p>
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('company-promotions.show', $company)}}">Promotions</a>
                                </p>
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('company-events.show', $company)}}">Events</a>
                                </p>
                                <p class="rounded-lg shadow-lg px-3 py-2 border-2 border-blue-200">
                                    <a href="{{route('view-qr-code', $menu)}}">View QR Code</a>
                                </p>
                            </div>
                        </div>
                    </div>
                @endforeach
            </div>
        </div>
    </div>
</x-app-layout>